.include "m8def.inc"

.def temp1 = r16
.def temp2 = r17
.def data = r18
.def tx = r19

.def zahl1 = r19
.def zahl2 = r20
.def zahl3 = r21
.def zahl = r22

.def TempH = r27
.def TempL = r28

.equ SCL = 0
.equ SDA = 1

.equ DS1621_Write = 0b10010000
.equ DS1621_Read  = 0b10010001

.cseg
	rjmp	start				;reset handle
	reti	;INT0 External Interrupt Request 0
	reti	;INT1 External Interrupt Request 1
	reti	;TIMER2 COMP Timer/Counter2 Compare Match
	reti	;TIMER2 OVF Timer/Counter2 Overflow
	reti	;TIMER1 CAPT Timer/Counter1 Capture Event
	reti	;TIMER1 COMPA Timer/Counter1 Compare Match A
	reti	;TIMER1 COMPB Timer/Counter1 Compare Match B
	reti	;TIMER1 OVF Timer/Counter1 Overflow
	reti	;TIMER0 OVF Timer/Counter0 Overflow
	reti	;SPI, STC Serial Transfer Complete
	reti	;USART, RXC USART, Rx Complete
	reti	;USART, UDRE USART Data Register Empty
	reti	;USART, TXC USART, Tx Complete
	reti	;ADC ADC Conversion Complete
	reti	;EE_RDY EEPROM Ready
	reti	;ANA_COMP Analog Comparator
	reti	;TWI Two-wire Serial Interface
	reti	;SPM_RDY Store Program Memory Ready

.include "I2C.inc"

start:
	ldi		temp1,LOW(RAMEND)	;LOW-Byte der obersten RAM-Adresse
	out		SPL,temp1
	ldi		temp1,HIGH(RAMEND)	;HIGH-Byte der obersten RAM-Adresse
	out		SPH,temp1


	sbi		UCSRB,TXEN			;TX aktivieren
	
	ldi		temp1,0b00000000	;Baudrate ...
	out		UBRRH, temp1
	ldi		temp1,25
	out		UBRRL, temp1		;...einstellen (9.600 @ 4MHz)


	sbi		DDRB,SCL			; SCL ist Ausgang
	sbi		DDRB,SDA			; SDA ist Ausgang
	sbi		PortB,SCL
	sbi		PortB,SDA

	rjmp	MainLoop			; Ab ins Programm!!!
reti

Multi_mit_10:
	mov		temp1,data

	add		data,temp1
	add		data,temp1
	add		data,temp1
	add		data,temp1
	add		data,temp1
	add		data,temp1
	add		data,temp1
	add		data,temp1
	add		data,temp1
ret

BinToASCII:
	mov		temp1,zahl

	ldi		zahl1,0
	ldi		zahl2,0
	ldi		zahl3,0

	cpi		temp1,200
	brlo	unter_200
	ldi		zahl1,2
	ldi		temp2,200
	sub		temp1,temp2
	rjmp	unter_100
	unter_200:				;0-199
	cpi		temp1,100
	brlo	unter_100
	ldi		zahl1,1
	ldi		temp2,100
	sub		temp1,temp2
	unter_100:				;0-99
	cpi		temp1,90
	brlo	unter_90
	ldi		zahl2,9
	ldi		temp2,90
	sub		temp1,temp2
	rjmp	unter_10
	unter_90:				;0-89
	cpi		temp1,80
	brlo	unter_80
	ldi		zahl2,8
	ldi		temp2,80
	sub		temp1,temp2
	rjmp	unter_10
	unter_80:				;0-79
	cpi		temp1,70
	brlo	unter_70
	ldi		zahl2,7
	ldi		temp2,70
	sub		temp1,temp2
	rjmp	unter_10
	unter_70:				;0-69
	cpi		temp1,60
	brlo	unter_60
	ldi		zahl2,6
	ldi		temp2,60
	sub		temp1,temp2
	rjmp	unter_10
	unter_60:				;0-59
	cpi		temp1,50
	brlo	unter_50
	ldi		zahl2,5
	ldi		temp2,50
	sub		temp1,temp2
	rjmp	unter_10
	unter_50:				;0-49
	cpi		temp1,40
	brlo	unter_40
	ldi		zahl2,4
	ldi		temp2,40
	sub		temp1,temp2
	rjmp	unter_10
	unter_40:				;0-39
	cpi		temp1,30
	brlo	unter_30
	ldi		zahl2,3
	ldi		temp2,30
	sub		temp1,temp2
	rjmp	unter_10
	unter_30:				;0-29
	cpi		temp1,20
	brlo	unter_20
	ldi		zahl2,2
	ldi		temp2,20
	sub		temp1,temp2
	rjmp	unter_10
	unter_20:				;0-19
	cpi		temp1,10
	brlo	unter_10
	ldi		zahl2,1
	ldi		temp2,10
	sub		temp1,temp2
	rjmp	unter_10
	unter_10:				;0-9
	mov		zahl3,temp1
ret

serout:
	sbis	UCSRA,UDRE  ;Warten, bis UDR fr das nchste Byte bereit ist
	rjmp	serout
	out		UDR, tx
ret               ;zurck zum Hauptprogramm

MainLoop:
	; Start
	rcall	I2C_Start

	; I2C-Adresse senden
	ldi		data,DS1621_Write
	rcall	I2C_Send
	rcall	I2C_Read_Ack

	; Command-Byte --> Grundeinstellungen
	ldi		data,0b10101100
	rcall	I2C_Send
	rcall	I2C_Read_Ack

	; Command-Byte --> Grundeinstellungen
	ldi		data,0b00000000
	rcall	I2C_Send
	rcall	I2C_Read_Ack

	; Stop
	rcall	I2C_Stop




	rcall	I2C_Wait
	rcall	I2C_Wait
	rcall	I2C_Wait




	; Start
	rcall	I2C_Start

	; I2C-Adresse senden
	ldi		data,DS1621_Write
	rcall	I2C_Send
	rcall	I2C_Read_Ack

	; Command-Byte --> Grundeinstellungen
	ldi		data,0b11101110
	rcall	I2C_Send
	rcall	I2C_Read_Ack

	; Stop
	rcall	I2C_Stop




	rcall	I2C_Wait
	rcall	I2C_Wait
	rcall	I2C_Wait



	Lese_Temp:
		; Start
		rcall	I2C_Start

		; I2C-Adresse senden
		ldi		data,DS1621_Write
		rcall	I2C_Send
		rcall	I2C_Read_Ack

		; Command-Byte zmu Temp. lesen
		ldi		data,0b10101010
		rcall	I2C_Send
		rcall	I2C_Read_Ack

		; Start
		rcall	I2C_Start

		; I2C-Adresse senden
		ldi		data,DS1621_Read
		rcall	I2C_Send
		rcall	I2C_Read_Ack

		; I2C-Daten-Byte lesen = Milli-Sekunden
		rcall	I2C_Read
		rcall	I2C_Send_Ack
		mov		TempH,data

		; I2C-Daten-Byte lesen = Sekunden
		rcall	I2C_Read
		rcall	I2C_Send_no_Ack
		mov		TempL,data

		; Stop
		rcall	I2C_Stop



		; Ausgabe auf PC
		mov		tx,TempH
		rcall	serout
		mov		tx,TempL
		rcall	serout




; ============================= 
;   Warteschleifen-Generator 
;     2000000 Zyklen:
; ----------------------------- 
; warte 1999998 Zyklen:
          ldi  R29, $12
WGLOOP10:  ldi  R30, $BC
WGLOOP11:  ldi  R31, $C4
WGLOOP12:  dec  R31
          brne WGLOOP12
          dec  R30
          brne WGLOOP11
          dec  R29
          brne WGLOOP10
; ----------------------------- 
; warte 2 Zyklen:
          nop
          nop
; ============================= 




		rjmp	Lese_Temp

	rjmp	MainLoop